{# Server Settings #}

{% include "consul-base-config.hcl.j2" %}

{## Node Role ##}
server = true

{## UI Config ##}
ui_config = {
  enabled = true
}

{## Enable Connect on Server ##}
connect = {
  enabled = true
}

{## Bootstrap settings ##}
bootstrap_expect = {{ consul_server_bootstrap_expect }}

{## AutoPilot ##}
autopilot = {}

{## TLS ##}
tls {
  defaults {
    verify_incoming        = true
    verify_outgoing        = true
    verify_server_hostname = true
    ca_file                = "{{ consul_tls_certs_path }}/{{ consul_tls_ca_file }}"
    cert_file              = "{{ consul_tls_certs_path }}/{{ consul_tls_cert_file }}"
    key_file               = "{{ consul_tls_certs_path }}/{{ consul_tls_key_file }}"
  }
  https {
    verify_incoming = false
  }
}
auto_encrypt {
  allow_tls = true
}

{## Service Registration ##}
service {
  name    = "consul-server"
  address = "{{ consul_bind_address }}"
  port    = 8501
  tags    = [
    "serf",
    "raft",
    "http",
    # tcp tags
    "traefik.enable=true",
    "traefik.consulcatalog.connect=false",
    "traefik.tcp.routers.consul-server.entrypoints=websecure",
    "traefik.tcp.services.consul-server.loadbalancer.server.port=8501",
    "traefik.tcp.routers.consul-server.tls.passthrough=true",
    "traefik.tcp.routers.consul-server.rule=HostSNI(`{{ traefik_dns_host }}`)",
    
    # http tags
    "traefik.http.routers.consul-server.entrypoints=web",
    "traefik.http.routers.consul-server.service=noop@internal",
    "traefik.http.routers.consul-server.middlewares=redirect-to-http-to-https@file",
    "traefik.http.routers.consul-server.rule=Host(`{{ traefik_dns_host }}`)"
  ]
  checks = [
    {
      id       = "serf-health"
      name     = "Consul Serf Health Check"
      interval = "10s"
      timeout  = "1s"
      status   = "critical"

      tcp = "{{ consul_bind_address }}:8301"
    },
    {
      id       = "raft-health"
      name     = "Consul Raft Health Check"
      interval = "10s"
      timeout  = "1s"
      status   = "critical"

      tcp = "{{ consul_bind_address }}:8300"
    },
    {
      id       = "http-health"
      name     = "Consul HTTP Health Check"
      interval = "10s"
      timeout  = "1s"
      status   = "critical"

      http            = "https://{{ consul_bind_address }}:8501/v1/status/leader"
      tls_skip_verify = true
    }
  ]
}
